-------------------------------------------------------
---------------------- Globals ------------------------
-------------------------------------------------------
Ahoy.TabsCount = 16;
Ahoy.selectedTab = -1;
Ahoy.selectedCreature = "";
Ahoy.animateBackground = true;
Ahoy.updateInterval = 0.1;
Ahoy.TimeSinceLastUpdate = 0;
Ahoy.cloudTexCoordIncrement = 0;
Ahoy.windowIsDragged = false;
Ahoy.TabFrames = {}
Ahoy.RewardBlocks = {}
Ahoy.canBroadcast = true;

-------------------------------------------------------
-------------------- MAINFRAME!! ----------------------
-------------------------------------------------------

AhoyMainFrame = CreateFrame("Frame","AhoyMainFrame",UIParent)
AhoyMainFrame:Hide();
AhoyMainFrame:SetFrameStrata("BACKGROUND")
AhoyMainFrame:SetWidth(450) -- Set these to whatever height/width is needed 
AhoyMainFrame:SetHeight(170) -- for your Texture
AhoyMainFrame:SetPoint("BOTTOMLEFT",1403,448)
local textureFrame4 = AhoyMainFrame:CreateTexture("BACKGROUND")
textureFrame4:SetTexture("Interface\\AddOns\\Ahoy\\Main.blp");
textureFrame4:SetTexCoord(0, 1, 0.640625, 1) 
textureFrame4:SetAllPoints(AhoyMainFrame)
AhoyMainFrame:SetMovable(true)
AhoyMainFrame:EnableMouse(true)
AhoyMainFrame:RegisterForDrag("LeftButton")
AhoyMainFrame:SetScript("OnDragStart", 
function() 
	if not Ahoy_Settings_New.WindowLocked then
		AhoyMainFrame:StartMoving() 
		Ahoy.windowIsDragged = true 
	end
end)
AhoyMainFrame:SetScript("OnDragStop", 
function() 
	if not Ahoy_Settings_New.WindowLocked then
		AhoyMainFrame:StopMovingOrSizing() 
		Ahoy.windowIsDragged = false
		local x = AhoyMainFrame:GetLeft()
		local y = AhoyMainFrame:GetBottom()
		Ahoy_Settings_New.MainFrameX = x
		Ahoy_Settings_New.MainFrameY = y
		Ahoy_Settings = Ahoy_Settings_New;
	end
end)
AhoyMainFrame:SetScript("OnMouseDown", 
function(self, arg1)
	if arg1 == "RightButton" then
		Ahoy_CloseMainframe()
		if Ahoy.InQueue == true then
			Ahoy.WindowClosedDuringQueue = true
		end
		if Ahoy.DoingIslandExpedition == false then
			Ahoy.WindowClosedOutsideExpedition = true
		end
	end
end)

function Ahoy_ToggleMainframe()
	if AhoyMainFrame:IsVisible() == true then
		AhoyMainFrame:Hide();
	else
		AhoyMainFrame:Show();
	end
end

function Ahoy_CloseMainframe()
	AhoyMainFrame:Hide();
end

function Ahoy_OpenMainframe()
	AhoyMainFrame:Show();
end

function Ahoy_MoveToSavedPosition()
	if Ahoy_Settings_New.MainFrameX ~= nil then
		AhoyMainFrame:ClearAllPoints()
		AhoyMainFrame:SetPoint("BOTTOMLEFT",Ahoy_Settings_New.MainFrameX,Ahoy_Settings_New.MainFrameY)
	end
end

function Ahoy_ResetMainframePosition()
		AhoyMainFrame:ClearAllPoints()
		AhoyMainFrame:SetPoint("CENTER",0,0)
		local x,y = AhoyMainFrame:GetCenter()
		Ahoy_Settings_New.MainFrameX = x
		Ahoy_Settings_New.MainFrameY = y
		Ahoy_Settings = Ahoy_Settings_New;
end

local function splits(s, delimiter)
    result = {};
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match);
    end
    return result;
end

---------------------------------------------------------
-------------------  Minimap Button  --------------------
---------------------------------------------------------

function Ahoy_MinimapButton_Reposition()
	if Ahoy_Settings_New.Toggle_HideMinimapIcon == true then
		Ahoy_MinimapButton:Hide();
	else
		Ahoy_MinimapButton:Show();
	end
	if Ahoy_Settings_New.MinimapPos ~= nil then
		Ahoy_MinimapButton:SetPoint("TOPLEFT","Minimap","TOPLEFT",52-(80*cos(Ahoy_Settings_New.MinimapPos)),(80*sin(Ahoy_Settings_New.MinimapPos))-52)
		Ahoy_MinimapButton.tooltip = "Ahoy!" .. "\n" .. "Left Click - Open" .. "\n" .. "Right Click - Reset Position"
	end
end

function Ahoy_MinimapButton_DraggingFrame_OnUpdate()
	local xpos,ypos = GetCursorPosition()
	local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom()

	xpos = xmin-xpos/UIParent:GetScale()+70 -- get coordinates as differences from the center of the minimap
	ypos = ypos/UIParent:GetScale()-ymin-70

	Ahoy_Settings_New.MinimapPos = math.deg(math.atan2(ypos,xpos)) -- save the degrees we are relative to the minimap center
	Ahoy_MinimapButton_Reposition() -- move the button
	Ahoy_Settings = Ahoy_Settings_New;
end

function Ahoy_MinimapButton_OnClick(arg1)
	if arg1 == "LeftButton" then
		Ahoy_ToggleMainframe()
	end
	if arg1 == "RightButton" then
		Ahoy_ResetMainframePosition()
	end
end

---------------------------------------------------------
------------------  Settings Window  --------------------
---------------------------------------------------------
local SettingsWindowFrame = CreateFrame("Frame",nil,AhoyMainFrame)
SettingsWindowFrame:SetWidth(430) -- Set these to whatever height/width is needed 
SettingsWindowFrame:SetHeight(150) -- for your Texture
SettingsWindowFrame:SetPoint("CENTER",0,0)
local SettingsWindowFrame_Texture = SettingsWindowFrame:CreateTexture() 
SettingsWindowFrame_Texture:SetAllPoints() 
SettingsWindowFrame_Texture:SetColorTexture(0,0,0,0.8)
SettingsWindowFrame.background = SettingsWindowFrame_Texture
SettingsWindowFrame:SetFrameLevel(20);
SettingsWindowFrame:SetFrameStrata("DIALOG");
SettingsWindowFrame:Hide()

Ahoy_CheckButton_ShowSelectedMobLoot = CreateFrame("CheckButton", "Ahoy_CheckButton_ShowSelectedMobLoot_GlobalName", SettingsWindowFrame, "ChatConfigCheckButtonTemplate");
Ahoy_CheckButton_ShowSelectedMobLoot:SetPoint("TOPLEFT", 10, -10);
Ahoy_CheckButton_ShowSelectedMobLoot_GlobalNameText:SetText(" Show Selected Mob Loot");
Ahoy_CheckButton_ShowSelectedMobLoot.tooltip = "When checked, Ahoy will display potential loot rewards from the targeted mob on the right tab.";
Ahoy_CheckButton_ShowSelectedMobLoot:SetScript("OnClick", function() Ahoy_Settings_New.Toggle_MobTargetLootDisplay = Ahoy_CheckButton_ShowSelectedMobLoot:GetChecked(); Ahoy_Settings = Ahoy_Settings_New; end);

Ahoy_CheckButton_TooltipShowMobCategory = CreateFrame("CheckButton", "Ahoy_CheckButton_TooltipShowMobCategory_GlobalName", SettingsWindowFrame, "ChatConfigCheckButtonTemplate");
Ahoy_CheckButton_TooltipShowMobCategory:SetPoint("TOPLEFT", 10, -30);
Ahoy_CheckButton_TooltipShowMobCategory_GlobalNameText:SetText(" Tooltip - Show Mob Category On Mouse Over");
Ahoy_CheckButton_TooltipShowMobCategory.tooltip = "When checked, Ahoy will display the category in which the mob you are mousing over belongs to in the tooltip.";
Ahoy_CheckButton_TooltipShowMobCategory:SetScript("OnClick", function() Ahoy_Settings_New.Toggle_MobMouseOverCategory = Ahoy_CheckButton_TooltipShowMobCategory:GetChecked(); Ahoy_Settings = Ahoy_Settings_New; end);

Ahoy_CheckButton_ShowRewardsAtTheEnd = CreateFrame("CheckButton", "Ahoy_CheckButton_ShowRewardsAtTheEnd_GlobalName", SettingsWindowFrame, "ChatConfigCheckButtonTemplate");
Ahoy_CheckButton_ShowRewardsAtTheEnd:SetPoint("TOPLEFT", 10, -50);
Ahoy_CheckButton_ShowRewardsAtTheEnd_GlobalNameText:SetText(" Show Rewards at the End");
Ahoy_CheckButton_ShowRewardsAtTheEnd.tooltip = "Instantly show rewards at the end of an expedition in the Ahoy window.";
Ahoy_CheckButton_ShowRewardsAtTheEnd:SetScript("OnClick", function() Ahoy_Settings_New.Toggle_ShowRewards = Ahoy_CheckButton_ShowRewardsAtTheEnd:GetChecked(); Ahoy_Settings = Ahoy_Settings_New; end);

Ahoy_CheckButton_AutoShowAhoyOnTable = CreateFrame("CheckButton", "Ahoy_CheckButton_AutoShowAhoyOnTable_GlobalName", SettingsWindowFrame, "ChatConfigCheckButtonTemplate");
Ahoy_CheckButton_AutoShowAhoyOnTable:SetPoint("TOPLEFT", 10, -70);
Ahoy_CheckButton_AutoShowAhoyOnTable_GlobalNameText:SetText(" Auto Open Ahoy with the Expedition Map");
Ahoy_CheckButton_AutoShowAhoyOnTable.tooltip = "The Ahoy window will open automatically when you click the Expedition Map";
Ahoy_CheckButton_AutoShowAhoyOnTable:SetScript("OnClick", function() Ahoy_Settings_New.Toggle_AutoShowAhoyOnMissionTable = Ahoy_CheckButton_AutoShowAhoyOnTable:GetChecked(); Ahoy_Settings = Ahoy_Settings_New; end);

Ahoy_CheckButton_AutoShowAhoyOnIsland = CreateFrame("CheckButton", "Ahoy_CheckButton_AutoShowAhoyOnIsland_GlobalName", SettingsWindowFrame, "ChatConfigCheckButtonTemplate");
Ahoy_CheckButton_AutoShowAhoyOnIsland:SetPoint("TOPLEFT", 10, -90);
Ahoy_CheckButton_AutoShowAhoyOnIsland_GlobalNameText:SetText(" Auto Open Ahoy when starting a new Island Expedition");
Ahoy_CheckButton_AutoShowAhoyOnIsland.tooltip = "The Ahoy window will open automatically when a new Island Expedition Begins";
Ahoy_CheckButton_AutoShowAhoyOnIsland:SetScript("OnClick", function() Ahoy_Settings_New.Toggle_AutoShowAhoyOnIsland = Ahoy_CheckButton_AutoShowAhoyOnIsland:GetChecked(); Ahoy_Settings = Ahoy_Settings_New; end);

Ahoy_CheckButton_HideMinimapButton = CreateFrame("CheckButton", "Ahoy_CheckButton_HideMinimapButton_GlobalName", SettingsWindowFrame, "ChatConfigCheckButtonTemplate");
Ahoy_CheckButton_HideMinimapButton:SetPoint("TOPLEFT", 10, -110);
Ahoy_CheckButton_HideMinimapButton_GlobalNameText:SetText(" Hide the minimap button.");
Ahoy_CheckButton_HideMinimapButton.tooltip = "Hides the minimap button, ahoy can be opened with the /ahoy chat command too.";
Ahoy_CheckButton_HideMinimapButton:SetScript("OnClick", 
function() 
	Ahoy_Settings_New.Toggle_HideMinimapIcon = Ahoy_CheckButton_HideMinimapButton:GetChecked();
	Ahoy_Settings = Ahoy_Settings_New;
	Ahoy_MinimapButton_Reposition()
end);

function Ahoy_LoadCheckButtonStates()
	Ahoy_CheckButton_ShowSelectedMobLoot:SetChecked(Ahoy_Settings_New.Toggle_MobTargetLootDisplay);
	Ahoy_CheckButton_TooltipShowMobCategory:SetChecked(Ahoy_Settings_New.Toggle_MobMouseOverCategory);
	Ahoy_CheckButton_ShowRewardsAtTheEnd:SetChecked(Ahoy_Settings_New.Toggle_ShowRewards);
	Ahoy_CheckButton_AutoShowAhoyOnTable:SetChecked(Ahoy_Settings_New.Toggle_AutoShowAhoyOnMissionTable);
	Ahoy_CheckButton_AutoShowAhoyOnIsland:SetChecked(Ahoy_Settings_New.Toggle_AutoShowAhoyOnIsland);
	Ahoy_CheckButton_HideMinimapButton:SetChecked(Ahoy_Settings_New.Toggle_HideMinimapIcon);
end

-- Close Settings Button --
local CloseSettingsButton = CreateFrame("Button", nil, SettingsWindowFrame)
CloseSettingsButton:SetPoint("CENTER", 0, -90)
CloseSettingsButton:SetWidth(120)
CloseSettingsButton:SetHeight(30)
CloseSettingsButton:SetText("Close Settings")
CloseSettingsButton:SetNormalFontObject("GameFontNormal")
local CloseSettingsButton_ntex = CloseSettingsButton:CreateTexture()
CloseSettingsButton_ntex:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
CloseSettingsButton_ntex:SetTexCoord(0, 0.625, 0, 0.6875)
CloseSettingsButton_ntex:SetAllPoints()	
CloseSettingsButton:SetNormalTexture(CloseSettingsButton_ntex)
local CloseSettingsButton_htex = CloseSettingsButton:CreateTexture()
CloseSettingsButton_htex:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
CloseSettingsButton_htex:SetTexCoord(0, 0.625, 0, 0.6875)
CloseSettingsButton_htex:SetAllPoints()
CloseSettingsButton:SetHighlightTexture(CloseSettingsButton_htex)
local CloseSettingsButton_ptex = CloseSettingsButton:CreateTexture()
CloseSettingsButton_ptex:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
CloseSettingsButton_ptex:SetTexCoord(0, 0.625, 0, 0.6875)
CloseSettingsButton_ptex:SetAllPoints()
CloseSettingsButton:SetPushedTexture(CloseSettingsButton_ptex)
CloseSettingsButton:SetScript("OnClick", 
	function (self, button, down)
		SettingsWindowFrame:Hide()
	end)

---------------------------------------------------------
--------------------  Help Window  ----------------------
---------------------------------------------------------
local Ahoy_HelpFrame = CreateFrame("Frame", name, AhoyMainFrame)
Ahoy_HelpFrame:SetSize(512, 512)
Ahoy_HelpFrame:SetPoint("CENTER", 2, 2)
local Ahoy_HelpFrame_Texture = Ahoy_HelpFrame:CreateTexture() 
Ahoy_HelpFrame_Texture:SetAllPoints() 
Ahoy_HelpFrame_Texture:SetTexture("Interface\\AddOns\\Ahoy\\Help.blp");
--HelpFrame_Texture:SetTexCoord(0.9, 1, 0, 0.1)
Ahoy_HelpFrame.background = Ahoy_HelpFrame_Texture
Ahoy_HelpFrame:SetScript("OnMouseDown", 
function(self, arg1)
	Ahoy_HelpFrame:Hide();
end)
Ahoy_HelpFrame:SetFrameLevel(30);
Ahoy_HelpFrame:Hide();

---------------------------------------------------------
------------------------  Menu  -------------------------
---------------------------------------------------------

local MenuFrame = CreateFrame("Frame", name, AhoyMainFrame)
local MenuItem1Frame = CreateFrame("Frame", name, MenuFrame)
local MenuItem2Frame = CreateFrame("Frame", name, MenuFrame)
local MenuItem3Frame = CreateFrame("Frame", name, MenuFrame)
local MenuItem4Frame = CreateFrame("Frame", name, MenuFrame)
local MenuItem5Frame = CreateFrame("Frame", name, MenuFrame)
MenuItem6Frame = CreateFrame("Frame", name, MenuFrame)

local function AhoyToggleMenu()
	if MenuFrame:IsVisible() == true then
		MenuFrame:Hide();
	else
		MenuFrame:Show();
	end
	SettingsWindowFrame:Hide()
end

MenuFrame:SetSize(170, 150)
MenuFrame:SetPoint("CENTER", 0, 100)
local MenuFrame_Texture = MenuFrame:CreateTexture() 
MenuFrame_Texture:SetAllPoints() 
MenuFrame_Texture:SetColorTexture(0,0,0,0)
MenuFrame.background = MenuFrame_Texture

MenuItem1Frame:SetSize(40, 40)
MenuItem1Frame:SetPoint("CENTER", 0, 50)
local MenuItem1Frame_Texture = MenuItem1Frame:CreateTexture() 
MenuItem1Frame_Texture:SetAllPoints() 
MenuItem1Frame_Texture:SetTexture("Interface\\AddOns\\Ahoy\\Main.blp");
MenuItem1Frame_Texture:SetTexCoord(0.9, 1, 0, 0.1)
MenuItem1Frame.background = MenuItem1Frame_Texture
MenuItem1Frame:SetScript("OnMouseDown", 
function(self, arg1)
	AhoyToggleMenu();
    print("Full Item List not available yet.");
end)
MenuFrame:Hide();

MenuItem2Frame:SetSize(40, 40)
MenuItem2Frame:SetPoint("CENTER", -50, 10)
local MenuItem2Frame_Texture = MenuItem2Frame:CreateTexture() 
MenuItem2Frame_Texture:SetAllPoints() 
MenuItem2Frame_Texture:SetTexture("Interface\\AddOns\\Ahoy\\Main.blp");
MenuItem2Frame_Texture:SetTexCoord(0.9, 1, 0.12, 0.22)
MenuItem2Frame.background = MenuItem2Frame_Texture
MenuItem2Frame:SetScript("OnMouseDown", 
function(self, arg1)
	AhoyToggleMenu();
	Ahoy_LoadCheckButtonStates()
    SettingsWindowFrame:Show()
end)

MenuItem3Frame:SetSize(40, 40)
MenuItem3Frame:SetPoint("CENTER", 50, 10)
local MenuItem3Frame_Texture = MenuItem3Frame:CreateTexture() 
MenuItem3Frame_Texture:SetAllPoints() 
MenuItem3Frame_Texture:SetTexture("Interface\\AddOns\\Ahoy\\Main.blp");
MenuItem3Frame_Texture:SetTexCoord(0.9, 1, 0.235, 0.335) 
MenuItem3Frame.background = MenuItem3Frame_Texture
MenuItem3Frame:SetScript("OnMouseDown", 
function(self, arg1)
	AhoyToggleMenu();
    Ahoy_HelpFrame:Show();
end)

MenuItem4Frame:SetSize(40, 40)
MenuItem4Frame:SetPoint("CENTER", -100, 10)
local MenuItem4Frame_Texture = MenuItem4Frame:CreateTexture() 
MenuItem4Frame_Texture:SetAllPoints() 
MenuItem4Frame_Texture:SetTexture("Interface\\AddOns\\Ahoy\\Main.blp");
MenuItem4Frame_Texture:SetTexCoord(0.798, 0.9, 0.235, 0.335)
MenuItem4Frame.background = MenuItem4Frame_Texture
MenuItem4Frame:SetScript("OnMouseDown", 
function(self, arg1)
	local point, relativeTo, relativePoint, x, y = AhoyMainFrame:GetPoint(1);
	local currentScale = AhoyMainFrame:GetScale()
	local newScale = currentScale + 0.05;
	if newScale < 3 then
		AhoyMainFrame:SetScale(newScale);
		Ahoy_Settings_New.WindowScale = newScale;
		Ahoy_Settings = Ahoy_Settings_New;
		print ("Ahoy Scale: " .. newScale);
	end
end)

MenuItem5Frame:SetSize(40, 40)
MenuItem5Frame:SetPoint("CENTER", -150, 10)
local MenuItem5Frame_Texture = MenuItem5Frame:CreateTexture() 
MenuItem5Frame_Texture:SetAllPoints() 
MenuItem5Frame_Texture:SetTexture("Interface\\AddOns\\Ahoy\\Main.blp");
MenuItem5Frame_Texture:SetTexCoord(0.798, 0.9, 0.122, 0.22)
MenuItem5Frame.background = MenuItem5Frame_Texture
MenuItem5Frame:SetScript("OnMouseDown", 
function(self, arg1)
	local point, relativeTo, relativePoint, x, y = AhoyMainFrame:GetPoint(1);
	local currentScale = AhoyMainFrame:GetScale()
	local newScale = currentScale - 0.05;
	if newScale > 0.4 then
	AhoyMainFrame:SetScale(newScale);
		Ahoy_Settings_New.WindowScale = newScale;
		Ahoy_Settings = Ahoy_Settings_New;
		print ("Ahoy Scale: " .. newScale);
	end
end)

MenuItem6Frame:SetSize(40, 40)
MenuItem6Frame:SetPoint("CENTER", 100, 10)
local MenuItem6Frame_Texture = MenuItem6Frame:CreateTexture() 
MenuItem6Frame_Texture:SetAllPoints() 
MenuItem6Frame_Texture:SetTexture("Interface\\AddOns\\Ahoy\\Main.blp");
MenuItem6Frame_Texture:SetTexCoord(0.69, 0.79, 0.122, 0.22)
MenuItem6Frame.background = MenuItem6Frame_Texture
MenuItem6Frame:SetScript("OnMouseDown", 
function(self, arg1)
	Ahoy_Settings_New.WindowLocked = not Ahoy_Settings_New.WindowLocked;
	if Ahoy_Settings_New.WindowLocked then
		-- change icon to locked
		MenuItem6Frame.background:SetTexCoord(0.69, 0.79, 0.122, 0.22)
	else
		-- change icon to unlocked
		MenuItem6Frame.background:SetTexCoord(0.69, 0.79, 0.235, 0.335)
	end
	Ahoy_Settings = Ahoy_Settings_New;
end)

-------------------------------------------------------
---------------- Splashscreen Window ------------------
-------------------------------------------------------
local SplashscreenWindowFrame = CreateFrame("Frame",nil,AhoyMainFrame)
SplashscreenWindowFrame:SetWidth(430) -- Set these to whatever height/width is needed 
SplashscreenWindowFrame:SetHeight(150) -- for your Texture
SplashscreenWindowFrame:SetPoint("CENTER",0,0)
local SplashscreenWindowFrame_Texture = SplashscreenWindowFrame:CreateTexture() 
SplashscreenWindowFrame_Texture:SetAllPoints() 
SplashscreenWindowFrame_Texture:SetTexture("Interface/garrison/garrisonmissionlocationnagrandsea", "REPEAT", "REPEAT");
SplashscreenWindowFrame_Texture:SetTexCoord(0, 1, 0, 0.25) 
SplashscreenWindowFrame_Texture:SetHorizTile(true)
SplashscreenWindowFrame.background = SplashscreenWindowFrame_Texture
SplashscreenWindowFrame:SetFrameLevel(8);

local SplashScreenWater = CreateFrame("Frame",nil,SplashscreenWindowFrame)
SplashScreenWater:SetWidth(430) -- Set these to whatever height/width is needed 
SplashScreenWater:SetHeight(200) -- for your Texture
SplashScreenWater:SetPoint("CENTER",0,25)
local SplashScreenWater_Texture = SplashScreenWater:CreateTexture() 
SplashScreenWater_Texture:SetAllPoints() 
SplashScreenWater_Texture:SetTexture("Interface/garrison/garrisonmissionlocationnagrandsea");
SplashScreenWater_Texture:SetTexCoord(0, 1, 0.5, 0.8) 
SplashScreenWater.background = SplashScreenWater_Texture
SplashScreenWater:SetFrameLevel(9);

local SplashScreenWaterReflection = CreateFrame("Frame",nil,SplashscreenWindowFrame)
SplashScreenWaterReflection:SetWidth(430) -- Set these to whatever height/width is needed 
SplashScreenWaterReflection:SetHeight(70) -- for your Texture
SplashScreenWaterReflection:SetPoint("CENTER",0,-45)
SplashScreenWaterReflection:SetAlpha(.2);
local SplashScreenWaterReflection_Texture = SplashScreenWaterReflection:CreateTexture() 
SplashScreenWaterReflection_Texture:SetAllPoints() 
SplashScreenWaterReflection_Texture:SetTexture("Interface/garrison/garrisonmissionlocationnagrandsea", "REPEAT", "REPEAT");
SplashScreenWaterReflection_Texture:SetTexCoord(0, 1, 0.125, 0) 
SplashScreenWaterReflection_Texture:SetHorizTile(true)
SplashScreenWaterReflection.background = SplashScreenWaterReflection_Texture
SplashScreenWaterReflection:SetFrameLevel(10);

local SplashScreenLogo = CreateFrame("Frame",nil,SplashscreenWindowFrame)
SplashScreenLogo:SetWidth(240) -- Set these to whatever height/width is needed 
SplashScreenLogo:SetHeight(90) -- for your Texture
SplashScreenLogo:SetPoint("LEFT",30,0)
local SplashScreenLogo_Texture = SplashScreenLogo:CreateTexture() 
SplashScreenLogo_Texture:SetAllPoints() 
SplashScreenLogo_Texture:SetTexture("Interface\\AddOns\\Ahoy\\Main.blp");
SplashScreenLogo_Texture:SetTexCoord(0, 0.468, 0, 0.175) 
SplashScreenLogo.background = SplashScreenLogo_Texture
SplashScreenLogo:SetFrameLevel(11);

local SplashScreenInfo = CreateFrame("Frame",nil,SplashscreenWindowFrame)
SplashScreenInfo:SetWidth(240) -- Set these to whatever height/width is needed 
SplashScreenInfo:SetHeight(90) -- for your Texture
SplashScreenInfo:SetPoint("BOTTOMRIGHT",0,0)
SplashScreenInfo:SetFrameLevel(12);
SplashScreenInfo.text = SplashScreenInfo.text or SplashScreenInfo:CreateFontString(nil,"ARTWORK","GameFontNormal")
SplashScreenInfo.text:SetAllPoints(true)
SplashScreenInfo.text:SetJustifyH("RIGHT")
SplashScreenInfo.text:SetJustifyV("BOTTOM")
SplashScreenInfo.text:SetText("Ahoy v" .. Ahoy_Version .. "\n" .. "by Songzee");
SplashScreenInfo.text:SetFont("fonts/arhei.ttf", 10, "NONE")
SplashScreenInfo.text:SetTextColor(1,1,1,0.5)


-------------------------------------------------------
-------------------- Queue Window ---------------------
-------------------------------------------------------
local QueueWindowFrame = CreateFrame("Frame",nil,AhoyMainFrame)
QueueWindowFrame:SetWidth(100) -- Set these to whatever height/width is needed 
QueueWindowFrame:SetHeight(100) -- for your Texture
QueueWindowFrame:SetPoint("CENTER",0,0)
local QueueWindowFrame_Texture = QueueWindowFrame:CreateTexture() 
QueueWindowFrame_Texture:SetAllPoints() 
QueueWindowFrame_Texture:SetTexture("Interface/timer/challenges-logo")
QueueWindowFrame.background = QueueWindowFrame_Texture

-------------------------------------------------------
----------------- Expedition Window -------------------
-------------------------------------------------------

local ExpeditionWindowFrame = CreateFrame("Frame",nil,AhoyMainFrame)
ExpeditionWindowFrame:SetWidth(450) -- Set these to whatever height/width is needed 
ExpeditionWindowFrame:SetHeight(170) -- for your Texture
ExpeditionWindowFrame:SetPoint("CENTER",0,0)
local ExpeditionWindowFrame_Texture = ExpeditionWindowFrame:CreateTexture() 
ExpeditionWindowFrame_Texture:SetAllPoints() 
ExpeditionWindowFrame_Texture:SetColorTexture(0,0,0,0)
ExpeditionWindowFrame.background = ExpeditionWindowFrame_Texture
ExpeditionWindowFrame:Hide()

-------------------------------------------------------
------------------- Rewards Window --------------------
-------------------------------------------------------

local RewardsWindowFrame = CreateFrame("Frame",nil,AhoyMainFrame)
RewardsWindowFrame:SetWidth(430) -- Set these to whatever height/width is needed 
RewardsWindowFrame:SetHeight(150) -- for your Texture
RewardsWindowFrame:SetPoint("CENTER",0,0)
local RewardsWindowFrame_Texture = RewardsWindowFrame:CreateTexture() 
RewardsWindowFrame_Texture:SetAllPoints() 
RewardsWindowFrame_Texture:SetColorTexture(0,0,0,0.8)
RewardsWindowFrame.background = RewardsWindowFrame_Texture
RewardsWindowFrame.text = RewardsWindowFrame.text or RewardsWindowFrame:CreateFontString(nil,"ARTWORK","GameFontNormal")
RewardsWindowFrame.text:SetAllPoints(true)
RewardsWindowFrame.text:SetJustifyH("CENTER")
RewardsWindowFrame.text:SetJustifyV("CENTER")
RewardsWindowFrame:Hide()

-------------------------------------------------------
------------------- Reward Blocks ---------------------
-------------------------------------------------------

for r = 0, 8, 1 do
	local RewardBlockFrame = CreateFrame("Frame",nil,RewardsWindowFrame)
	RewardBlockFrame:SetWidth(140)
	RewardBlockFrame:SetHeight(40)
	RewardBlockFrame:SetPoint("CENTER",0,0)
	local RewardBlockFrame_Texture = RewardBlockFrame:CreateTexture() 
	RewardBlockFrame_Texture:SetAllPoints() 
	RewardBlockFrame_Texture:SetTexture("Interface\\AddOns\\Ahoy\\Main.blp");
	RewardBlockFrame_Texture:SetTexCoord(0.47, 0.9, 0, 0.12)
	RewardBlockFrame.background = RewardBlockFrame_Texture
	RewardBlockFrame:SetHyperlinksEnabled(true)
	RewardBlockFrame:SetScript("OnMouseDown", 
		function() 
			child1, child2 = RewardBlockFrame:GetChildren();
			local link = child2.text:GetText();
			SetItemRef(link, link, nil, RewardBlockFrame)
		end)

	local RewardBlockIcon = CreateFrame("Frame",nil,RewardBlockFrame)
	RewardBlockIcon:SetWidth(38)
	RewardBlockIcon:SetHeight(38)
	RewardBlockIcon:SetPoint("LEFT",2,0)
	local RewardBlockIcon_Texture = RewardBlockIcon:CreateTexture() 
	RewardBlockIcon_Texture:SetAllPoints() 
	RewardBlockIcon.background = RewardBlockIcon_Texture

	local RewardBlockText = CreateFrame("Frame",nil,RewardBlockFrame)
	RewardBlockText:SetWidth(100)
	RewardBlockText:SetHeight(40)
	RewardBlockText:SetPoint("RIGHT",2,0)
	RewardBlockText.text = RewardBlockText.text or RewardBlockText:CreateFontString(nil,"ARTWORK","GameFontNormal")
	RewardBlockText.text:SetAllPoints(true)
	RewardBlockText.text:SetJustifyH("CENTER")
	RewardBlockText.text:SetJustifyV("CENTER")
	RewardBlockText.text:SetText(r);
	RewardBlockText:SetHyperlinksEnabled(true)
	RewardBlockText:SetScript("OnHyperlinkClick", 
	function(self,link,text,button) 
		SetItemRef(link, text, button, RewardBlockFrame)
	end);

	Ahoy.RewardBlocks[r] = RewardBlockFrame;
end

-- Close Rewards Button --
local CloseRewardsButton = CreateFrame("Button", nil, RewardsWindowFrame)
CloseRewardsButton:SetPoint("CENTER", 0, -90)
CloseRewardsButton:SetWidth(120)
CloseRewardsButton:SetHeight(30)
CloseRewardsButton:SetText("Close Rewards")
CloseRewardsButton:SetNormalFontObject("GameFontNormal")
local CloseRewardsButton_ntex = CloseRewardsButton:CreateTexture()
CloseRewardsButton_ntex:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
CloseRewardsButton_ntex:SetTexCoord(0, 0.625, 0, 0.6875)
CloseRewardsButton_ntex:SetAllPoints()	
CloseRewardsButton:SetNormalTexture(CloseRewardsButton_ntex)
local CloseRewardsButton_htex = CloseRewardsButton:CreateTexture()
CloseRewardsButton_htex:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
CloseRewardsButton_htex:SetTexCoord(0, 0.625, 0, 0.6875)
CloseRewardsButton_htex:SetAllPoints()
CloseRewardsButton:SetHighlightTexture(CloseRewardsButton_htex)
local CloseRewardsButton_ptex = CloseRewardsButton:CreateTexture()
CloseRewardsButton_ptex:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
CloseRewardsButton_ptex:SetTexCoord(0, 0.625, 0, 0.6875)
CloseRewardsButton_ptex:SetAllPoints()
CloseRewardsButton:SetPushedTexture(CloseRewardsButton_ptex)
CloseRewardsButton:SetScript("OnClick", 
	function (self, button, down)
		Ahoy_WindowSwitch("Expedition")
	end)

function RewardBlocksReposition (blockNumber)

	for r = 0, 8, 1 do
		if blockNumber-1 < r then
			Ahoy.RewardBlocks[r]:Hide();
		else
			Ahoy.RewardBlocks[r]:Show();
		end
	end

	local spacing = 5;
	-- 1x1 --
	if blockNumber == 1 then
		Ahoy.RewardBlocks[0]:SetPoint("CENTER",0,0);
	end
	-- 2x1 --
	if blockNumber == 2 then
		Ahoy.RewardBlocks[0]:SetPoint("CENTER",-67.5 - spacing,0);
		Ahoy.RewardBlocks[1]:SetPoint("CENTER",67.5 + spacing,0);
	end
	-- 2x2 --
	if blockNumber > 2 and blockNumber < 5 then
		Ahoy.RewardBlocks[0]:SetPoint("CENTER",-67.5 - spacing,20 + spacing/2);
		Ahoy.RewardBlocks[1]:SetPoint("CENTER",67.5 + spacing,20 + spacing/2);
		Ahoy.RewardBlocks[2]:SetPoint("CENTER",-67.5 - spacing,-20 - spacing/2);
		Ahoy.RewardBlocks[3]:SetPoint("CENTER",67.5 + spacing,-20 - spacing/2);
	end
	-- 3x2 --
	if blockNumber > 4 and blockNumber < 7 then
		Ahoy.RewardBlocks[0]:SetPoint("CENTER",-135 - spacing,20 + spacing/2);
		Ahoy.RewardBlocks[1]:SetPoint("CENTER",0,20 + spacing/2);
		Ahoy.RewardBlocks[2]:SetPoint("CENTER",135 + spacing,20 + spacing/2);
		Ahoy.RewardBlocks[3]:SetPoint("CENTER",-135 - spacing,-20 - spacing/2);
		Ahoy.RewardBlocks[4]:SetPoint("CENTER",0,-20 - spacing/2);
		Ahoy.RewardBlocks[5]:SetPoint("CENTER",135 + spacing,-20 - spacing/2);
	end
	-- 3x3 --
	if blockNumber > 6 and blockNumber < 10 then
		Ahoy.RewardBlocks[0]:SetPoint("CENTER",-135 - spacing,40 + spacing);
		Ahoy.RewardBlocks[1]:SetPoint("CENTER",0,40 + spacing);
		Ahoy.RewardBlocks[2]:SetPoint("CENTER",135 + spacing,40 + spacing);
		Ahoy.RewardBlocks[3]:SetPoint("CENTER",-135 - spacing,0);
		Ahoy.RewardBlocks[4]:SetPoint("CENTER",0,0);
		Ahoy.RewardBlocks[5]:SetPoint("CENTER",135 + spacing,0);
		Ahoy.RewardBlocks[6]:SetPoint("CENTER",-135 - spacing,-40 - spacing);
		Ahoy.RewardBlocks[7]:SetPoint("CENTER",0,-40 - spacing);
		Ahoy.RewardBlocks[8]:SetPoint("CENTER",135 + spacing,-40 - spacing);
	end
end

function Ahoy_UpdateRewardsUI(numRewards)
	itemCounter = 0;
	for i = 1, numRewards do
		local texture, quantity, isBonus, bonusQuantity, name, quality, id, objectType = GetLFGCompletionRewardItem(i);
		if objectType == "item" then
			itemCounter = itemCounter + 1;
			local objectLink = GetLFGCompletionRewardItemLink(i);
			child1, child2 = Ahoy.RewardBlocks[itemCounter-1]:GetChildren();
			child1.background:SetTexture(texture);
			child2.text:SetText(objectLink);
		end
	end
	RewardBlocksReposition(itemCounter);
end

-------------------------------------------------------
------------------  Window Switcher -------------------
-------------------------------------------------------
function Ahoy_WindowSwitch(window)
	if window == "Splashscreen" then
		SplashscreenWindowFrame:Show()
		QueueWindowFrame:Hide()
		ExpeditionWindowFrame:Hide()
		RewardsWindowFrame:Hide()
		Ahoy.animateBackground = true;
	end
	if window == "Queue" then
		SplashscreenWindowFrame:Hide()
		QueueWindowFrame:Show()
		ExpeditionWindowFrame:Hide()
		RewardsWindowFrame:Hide()
		Ahoy.animateBackground = false;
	end
	if window == "Expedition" then
		SplashscreenWindowFrame:Hide()
		QueueWindowFrame:Hide()
		ExpeditionWindowFrame:Show()
		RewardsWindowFrame:Hide()
		Ahoy.animateBackground = false;
	end
	if window == "Rewards" then
		SplashscreenWindowFrame:Hide()
		QueueWindowFrame:Hide()
		ExpeditionWindowFrame:Hide()
		RewardsWindowFrame:Show()
		Ahoy.animateBackground = false;
	end
end

-------------------------------------------------------
---------------------- Hat OuO ------------------------
-------------------------------------------------------

AhoyHatFrame = CreateFrame("Frame",nil,AhoyMainFrame)
AhoyHatFrame:SetFrameStrata("BACKGROUND")
AhoyHatFrame:SetWidth(70) -- Set these to whatever height/width is needed 
AhoyHatFrame:SetHeight(45) -- for your Texture
AhoyHatFrame:SetPoint("CENTER",0,90)
AhoyHatFrame_Texture = AhoyHatFrame:CreateTexture("BACKGROUND")
AhoyHatFrame_Texture:SetTexture("Interface\\AddOns\\Ahoy\\Main.blp");
AhoyHatFrame_Texture:SetTexCoord(0.75, 1, .5, 0.640625) 
AhoyHatFrame_Texture:SetAllPoints(AhoyHatFrame)
AhoyHatFrame:EnableMouse()
AhoyHatFrame:SetScript('OnEnter', 
function()
	AhoyHatFrame_Texture:SetTexCoord(0.75, 1, .5-0.140625, 0.640625-0.140625) 
	AhoyHatFrame:SetPoint("CENTER",0,95)
end)
AhoyHatFrame:SetScript('OnLeave', 
function()
	AhoyHatFrame_Texture:SetTexCoord(0.75, 1, .5, 0.640625) 
	AhoyHatFrame:SetPoint("CENTER",0,90)
end)
AhoyHatFrame:SetScript("OnMouseDown", 
function() 
	AhoyToggleMenu();
	AhoyHatFrame_Texture:SetTexCoord(0.75, 1, .5, 0.640625) 
	AhoyHatFrame:SetPoint("CENTER",0,90)
end)

-------------------------------------------------------
-------------- Score Scroll List Frames ---------------
-------------------------------------------------------

--parent frame 
AhoyScrollParentFrame = CreateFrame("Frame", "MyFrame", ExpeditionWindowFrame) 
AhoyScrollParentFrame:SetSize(220, 150) 
AhoyScrollParentFrame:SetPoint("LEFT",0,0) 
local AhoyScrollParentFrame_Texture = AhoyScrollParentFrame:CreateTexture() 
AhoyScrollParentFrame_Texture:SetAllPoints() 
AhoyScrollParentFrame_Texture:SetTexture(0,0,0,1) 
AhoyScrollParentFrame.background = AhoyScrollParentFrame_Texture 
 
--scrollframe 
AhoyScrollframe = CreateFrame("ScrollFrame", nil, AhoyScrollParentFrame) 
AhoyScrollframe:SetPoint("TOPLEFT", 10, -4) 
AhoyScrollframe:SetPoint("BOTTOMRIGHT", -10, 3) 
AhoyScrollParentFrame.AhoyScrollframe = AhoyScrollframe 
 
--scrollbar 
AhoyScrollbar = CreateFrame("Slider", nil, AhoyScrollframe, "UIPanelScrollBarTemplate") 
AhoyScrollbar:SetPoint("TOPLEFT", AhoyScrollParentFrame, "TOPRIGHT", -10, -16) 
AhoyScrollbar:SetPoint("BOTTOMLEFT", AhoyScrollParentFrame, "BOTTOMRIGHT", 4, 16) 
AhoyScrollbar:SetMinMaxValues(-1, 200) 
AhoyScrollbar:SetValueStep(1) 
AhoyScrollbar.scrollStep = 1
AhoyScrollbar:SetValue(0) 
AhoyScrollbar:SetWidth(16) 
AhoyScrollbar:SetScript("OnValueChanged", 
function (self, value) 
self:GetParent():SetVerticalScroll(value) 
end) 
local scrollbg = AhoyScrollbar:CreateTexture(nil, "BACKGROUND") 
scrollbg:SetAllPoints(AhoyScrollbar) 
scrollbg:SetTexture(0, 0, 0, 0.4) 
AhoyScrollParentFrame.AhoyScrollbar = AhoyScrollbar 
 
--content frame 
AhoyContentFrame = CreateFrame("Frame", nil, AhoyScrollframe) 
AhoyContentFrame:SetSize(220, 400) 
AhoyScrollframe.AhoyContentFrame = AhoyContentFrame 
AhoyScrollframe:SetScrollChild(AhoyContentFrame)

-------------------------------------------------------
-------------- Loot Scroll List Frames ----------------
-------------------------------------------------------
function Ahoy_GetLootString(selectedCreatureClass)
	local lootString = ""
	if AhoyItemDB[selectedCreatureClass] ~= nil then
		-- build loot string --
		local itemEntriesNumber = getn(AhoyItemDB[selectedCreatureClass]);
		for i = 1, itemEntriesNumber, 1 do
			local itemLink = AhoyItemDB[selectedCreatureClass][i];
			if Ahoy_Settings_New.ShowCollected == false then
				if Ahoy_CheckItemCollected(itemLink) == false then
					lootString = lootString .. " " .. itemLink .. "\n";
				end
			else
				lootString = lootString .. " " .. itemLink .. "\n";
			end
		end
	end
	return lootString;
end

function Ahoy_GetChatLootStrings(selectedCreatureClass)
	local lootStrings = {}
	if AhoyItemDB[selectedCreatureClass] ~= nil then
		-- build loot string --
		local itemEntriesNumber = getn(AhoyItemDB[selectedCreatureClass]);
		local stringBuffer = ""
		local index = 1;
		for i = 1, itemEntriesNumber, 1 do
			local itemLinkWH = AhoyItemDB[selectedCreatureClass][i];
			local _, _, Color, Ltype, id, Enchant, Gem1, Gem2, Gem3, Gem4, Suffix, Unique, LinkLvl, Name = string.find(itemLinkWH,"|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(id)
			if itemLink ~= nil then
				if strlen(stringBuffer..itemLink) > 250 then
					lootStrings[index] = stringBuffer;
					index = index + 1;
					stringBuffer = itemLink;
				else
					stringBuffer = stringBuffer.." "..itemLink;
					if i == itemEntriesNumber then
						lootStrings[index] = stringBuffer;
					end
				end
			end
		end
	end
	return lootStrings;
end

function Ahoy_UpdateLootList(selectedCreatureClass)
	local lootString = Ahoy_GetLootString(selectedCreatureClass)
	AhoyLootToolbarMobNameSubFrame.text:SetText(selectedCreatureClass);
	AhoyLootContentFrame.text:SetText(lootString);
	local height = AhoyLootContentFrame.text:GetStringHeight();
	AhoyLootContentFrame:SetHeight(height);
	AhoyLootScrollbar:SetMinMaxValues(-1, height/2) 
end

local function Ahoy_ShowHideCollected()
	if Ahoy_Settings_New.ShowCollected == true then
		Ahoy_Settings_New.ShowCollected = false;
		AhoyLootToolbarCollectedButton_Texture:SetTexCoord(0.460, 0.530, 0.640625 - 0.067, 0.640625) -- eye closed 1
	else
		Ahoy_Settings_New.ShowCollected = true;
		AhoyLootToolbarCollectedButton_Texture:SetTexCoord(0.360, 0.430, 0.640625 - 0.067, 0.640625) -- eye open
	end
	Ahoy_Settings = Ahoy_Settings_New;
	if Ahoy.selectedTab ~= -1 and Ahoy.selectedTab ~= nil then
		Ahoy_ClickedTab(Ahoy.selectedTab);
	else
		if Ahoy.selectedCreature ~= "" and Ahoy.selectedCreature ~= nil then
			Ahoy_SelectedCreature(Ahoy.selectedCreature);
		end
	end
end

local function AhoyBroadcastLoot()
	lootStrings = "";
	if Ahoy.selectedTab ~= -1 and Ahoy.selectedTab ~= nil then
		child1, child2, child3, child4 = Ahoy.TabFrames[Ahoy.selectedTab]:GetChildren();
		local selectedCreatureClass = child1.text:GetText();
		lootStrings = Ahoy_GetChatLootStrings(selectedCreatureClass)
	else
		if Ahoy.selectedCreature ~= "" and Ahoy.selectedCreature ~= nil then
			local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",Ahoy.selectedCreature);
			local npcRaw = AhoyCreatureDB[tonumber(npc_id)];
			if npcRaw ~= nil then
				local npcData = splits(npcRaw,"|");
				local npcClass = npcData[4];
				lootStrings = Ahoy_GetChatLootStrings(npcClass)
			end
		end
	end

	if getn(lootStrings) > 0 and strlen(lootStrings[1]) > 10 then
		lootStrings[0] = "Ahoy! Focus on " .. AhoyLootToolbarMobNameSubFrame.text:GetText() .. ". Potential rewards: ";
		for s = 0, getn(lootStrings), 1 do
			SendChatMessage(lootStrings[s] ,"INSTANCE_CHAT");
		end
	end
end

local function ReEnableBroadcastButton()
	AhoyLootToolbarBroadcastButton_Texture:SetTexture("Interface/Buttons/ui-guildbutton-motd-up");
	Ahoy.canBroadcast = true;
end

-- parent frame 
AhoyLootParentFrame = CreateFrame("Frame", "Loot Frame", ExpeditionWindowFrame) 
AhoyLootParentFrame:SetSize(165, 145) 
AhoyLootParentFrame:SetPoint("Right",-20,0) 
local AhoyLootParentFrame_Texture = AhoyLootParentFrame:CreateTexture() 
AhoyLootParentFrame_Texture:SetAllPoints() 
AhoyLootParentFrame_Texture:SetColorTexture(0,0,0,0) 
AhoyLootParentFrame.background = AhoyLootParentFrame_Texture 

--scrollframe 
local AhoyLootScrollFrame = CreateFrame("ScrollFrame", nil, AhoyLootParentFrame) 
AhoyLootScrollFrame:SetPoint("TOPLEFT", 4, -24) 
AhoyLootScrollFrame:SetPoint("BOTTOMRIGHT", -4, 4) 
AhoyLootScrollFrame:SetScript("OnMouseWheel", 
	function(self, delta)
		AhoyLootScrollbar:SetValue(AhoyLootScrollFrame:GetVerticalScroll()-(delta*20)) 
	end)
AhoyLootParentFrame.AhoyLootScrollFrame = AhoyLootScrollFrame 

--scrollbar 
AhoyLootScrollbar = CreateFrame("Slider", nil, AhoyLootScrollFrame, "UIPanelScrollBarTemplate") 
AhoyLootScrollbar:SetPoint("TOPLEFT", AhoyLootParentFrame, "TOPRIGHT", 2, -16) 
AhoyLootScrollbar:SetPoint("BOTTOMLEFT", AhoyLootParentFrame, "BOTTOMRIGHT", 20, 16) 
AhoyLootScrollbar:SetMinMaxValues(-1, 200) 
AhoyLootScrollbar:SetValueStep(1) 
AhoyLootScrollbar.scrollStep = 1
AhoyLootScrollbar:SetValue(0) 
AhoyLootScrollbar:SetWidth(16) 
AhoyLootScrollbar:SetScript("OnValueChanged", 
function (self, value) 
self:GetParent():SetVerticalScroll(value) 
end) 
local scrollbg1 = AhoyLootScrollbar:CreateTexture(nil, "BACKGROUND") 
scrollbg1:SetAllPoints(AhoyLootScrollbar) 
scrollbg1:SetTexture(0, 0, 0, 0.4) 
AhoyLootParentFrame.AhoyLootScrollbar = AhoyLootScrollbar 

--content frame 
AhoyLootContentFrame = CreateFrame("Frame", "Loot Scroll Frame", AhoyLootScrollFrame) 
AhoyLootContentFrame:SetSize(200, 300) 
AhoyLootContentFrame:SetPoint("Right",-25,0) 
AhoyLootContentFrame:EnableMouse();
AhoyLootContentFrame.text = AhoyLootContentFrame.text or AhoyLootContentFrame:CreateFontString(nil,"ARTWORK","GameFontNormal")
AhoyLootContentFrame.text:SetAllPoints(true)
AhoyLootContentFrame.text:SetJustifyH("LEFT")
AhoyLootContentFrame.text:SetJustifyV("TOP")
AhoyLootContentFrame:SetFrameLevel(100)
AhoyLootContentFrame:SetToplevel(true)
AhoyLootContentFrame:SetHyperlinksEnabled(true)
AhoyLootContentFrame:SetScript("OnHyperlinkClick", 
	function(self,link,text,button) 
		SetItemRef(link, text, button, AhoyLootContentFrame)
	end);
AhoyLootScrollFrame:SetScrollChild(AhoyLootContentFrame)

--toolbar Frame
AhoyLootToolbarFrame = CreateFrame("Frame", "Ahoy Loot Toolbar", AhoyLootParentFrame)
AhoyLootToolbarFrame:SetSize(170, 20)
AhoyLootToolbarFrame:SetPoint("CENTER", -2, 62)
		
-- toolbar SubFrames --
AhoyLootToolbarCollectedButton = CreateFrame("Frame", "Ahoy Loot Toolbar Collected Button", AhoyLootToolbarFrame)
AhoyLootToolbarCollectedButton:SetSize(15, 15)
AhoyLootToolbarCollectedButton:SetPoint("LEFT", 10, 0)
AhoyLootToolbarCollectedButton_Texture = AhoyLootToolbarCollectedButton:CreateTexture() 
AhoyLootToolbarCollectedButton_Texture:SetAllPoints() 
AhoyLootToolbarCollectedButton_Texture:SetTexture("Interface\\AddOns\\Ahoy\\Main.blp");
AhoyLootToolbarCollectedButton_Texture:SetTexCoord(0.755 - 0.067, 0.755, 0.640625 - 0.067, 0.640625)
AhoyLootToolbarCollectedButton.texture = AhoyLootToolbarCollectedButton_Texture
AhoyLootToolbarCollectedButton:SetScript("OnMouseDown", 
function() 
	Ahoy_ShowHideCollected()
end)

AhoyLootToolbarMobNameSubFrame = CreateFrame("Frame", "AhoyLootToolbarMobNameSubFrame", AhoyLootToolbarFrame)
AhoyLootToolbarMobNameSubFrame:SetSize(100, 20)
AhoyLootToolbarMobNameSubFrame:SetPoint("CENTER", 5, 0)
AhoyLootToolbarMobNameSubFrame.text = AhoyLootToolbarMobNameSubFrame.text or AhoyLootToolbarMobNameSubFrame:CreateFontString(nil,"ARTWORK","QuestFontNormalSmall")
AhoyLootToolbarMobNameSubFrame.text:SetAllPoints(true)
AhoyLootToolbarMobNameSubFrame.text:SetTextColor(1,1,1,0.8)
AhoyLootToolbarMobNameSubFrame.text:SetJustifyH("LEFT")
AhoyLootToolbarMobNameSubFrame.text:SetJustifyV("CENTER")
AhoyLootToolbarMobNameSubFrame.text:SetText(format(" "))

AhoyLootToolbarBroadcastButton = CreateFrame("Frame", "Ahoy Loot Toolbar Broadcast Button", AhoyLootToolbarFrame)
AhoyLootToolbarBroadcastButton:SetSize(15, 15)
AhoyLootToolbarBroadcastButton:SetPoint("RIGHT", -10, 0)
AhoyLootToolbarBroadcastButton_Texture = AhoyLootToolbarBroadcastButton:CreateTexture() 
AhoyLootToolbarBroadcastButton_Texture:SetAllPoints() 
AhoyLootToolbarBroadcastButton_Texture:SetTexture("Interface/Buttons/ui-guildbutton-motd-up");
AhoyLootToolbarBroadcastButton.texture = AhoyLootToolbarBroadcastButton_Texture
AhoyLootToolbarBroadcastButton:SetScript("OnMouseDown", 
function() 
	if Ahoy.canBroadcast == true then
		AhoyLootToolbarBroadcastButton_Texture:SetTexture("Interface/Buttons/ui-guildbutton-motd-disabled");
		Ahoy.canBroadcast = false;
		Ahoy__wait(3,ReEnableBroadcastButton);
		AhoyBroadcastLoot()
	end
end)

---------------------------------------------------------
-------------------  Tab Frames  ------------------------
---------------------------------------------------------

function Ahoy_ClickedTab(tabNumber)
	local lootString = ""
	child1, child2, child3, child4 = Ahoy.TabFrames[tabNumber]:GetChildren();
	local selectedCreatureClass = child1.text:GetText();
	Ahoy_UpdateLootList(selectedCreatureClass);
end

function ClearTabSelect()
	for n = 0, Ahoy.TabsCount, 1 do
		Ahoy.TabFrames[n].texture:SetTexCoord(0.04, 0.39, 0.345, 0.381);
	end
	Ahoy.selectedTab = -1
end

function Ahoy_CreateTabFrames()
	for t = 0, Ahoy.TabsCount, 1 do
		local AhoyTabFrame = CreateFrame("Frame", "AhoyTab "..t, AhoyContentFrame)
		AhoyTabFrame:SetSize(189, 20)
		AhoyTabFrame:SetPoint("CENTER", -14, 200-t*19.5 - 10)
		local AhoyTabFrame_texture = AhoyTabFrame:CreateTexture() 
		AhoyTabFrame_texture:SetAllPoints() 
		AhoyTabFrame_texture:SetTexture("Interface\\AddOns\\Ahoy\\Main.blp");
		AhoyTabFrame_texture:SetTexCoord(0.04, 0.39, 0.345, 0.381)
		AhoyTabFrame.texture = AhoyTabFrame_texture
		AhoyScrollframe.AhoyContentFrame = AhoyTabFrame

		--- Handle Controls ---
		AhoyTabFrame:EnableMouseWheel(true)
		AhoyTabFrame:EnableMouse()
		AhoyTabFrame:SetScript("OnMouseWheel", 
		function(self, delta)
			AhoyScrollbar:SetValue(AhoyScrollframe:GetVerticalScroll()-(delta*20)) 
		end)
		AhoyTabFrame:SetScript('OnEnter', 
		function()
			if t ~= Ahoy.selectedTab then
				AhoyTabFrame.texture:SetTexCoord(0.04, 0.39, 0.347 + 0.037, 0.383 + 0.037) 
			end
		end)
		AhoyTabFrame:SetScript('OnLeave', 
		function()
			if t ~= Ahoy.selectedTab then
				AhoyTabFrame.texture:SetTexCoord(0.04, 0.39, 0.345, 0.381)
			end
		end)
		AhoyTabFrame:SetScript("OnMouseDown", 
		function() 
			ClearTabSelect();
			Ahoy.selectedTab = t;
			Ahoy_ClickedTab(Ahoy.selectedTab);
			AhoyTabFrame.texture:SetTexCoord(0.04, 0.39, 0.349 + 0.074, 0.387 + 0.074)
		end)
		
		--- SUBFRAMES ---
		local MobNameSubFrame = CreateFrame("Frame", "MobName"..t, AhoyTabFrame)
		MobNameSubFrame:SetSize(100, 20)
		MobNameSubFrame:SetPoint("CENTER", 5, 0)
		MobNameSubFrame.text = MobNameSubFrame.text or MobNameSubFrame:CreateFontString(nil,"ARTWORK","QuestFontNormalSmall")
		MobNameSubFrame.text:SetAllPoints(true)
		MobNameSubFrame.text:SetJustifyH("LEFT")
		MobNameSubFrame.text:SetJustifyV("CENTER")
		MobNameSubFrame.text:SetText(format(" "))

		local MobScoreSubFrame = CreateFrame("Frame", "MobScore"..t, AhoyTabFrame)
		MobScoreSubFrame:SetSize(50, 20)
		MobScoreSubFrame:SetPoint("RIGHT", 6, 1)
		MobScoreSubFrame.text = MobScoreSubFrame.text or MobScoreSubFrame:CreateFontString(nil,"ARTWORK","GameFontNormal")
		MobScoreSubFrame.text:SetAllPoints(true)
		MobScoreSubFrame.text:SetJustifyH("RIGHT")
		MobScoreSubFrame.text:SetJustifyV("CENTER")
		MobScoreSubFrame.text:SetTextColor(1,1,0,1)
		MobScoreSubFrame.text:SetText(format(" "))

		local SilverSkullSubFrame = CreateFrame("Frame", "SilverSkull"..t, AhoyTabFrame)
		SilverSkullSubFrame:SetSize(15, 15)
		SilverSkullSubFrame:SetPoint("LEFT", 30, 0)
		local SilverSkullSubFrame_Texture = SilverSkullSubFrame:CreateTexture() 
		SilverSkullSubFrame_Texture:SetAllPoints() 
		SilverSkullSubFrame_Texture:SetTexture("Interface\\AddOns\\Ahoy\\Main.blp");
		SilverSkullSubFrame_Texture:SetTexCoord(0.755 - 0.067, 0.755, 0.640625 - 0.067, 0.640625)

		local SilverSkillScoreSubFrame = CreateFrame("Frame", "SilverSkillScore"..t, AhoyTabFrame)
		SilverSkillScoreSubFrame:SetSize(25, 20)
		SilverSkillScoreSubFrame:SetPoint("LEFT", 15, 0)
		SilverSkillScoreSubFrame.text = SilverSkillScoreSubFrame.text or SilverSkillScoreSubFrame:CreateFontString(nil,"ARTWORK","QuestFontNormalSmall")
		SilverSkillScoreSubFrame.text:SetAllPoints(true)
		SilverSkillScoreSubFrame.text:SetJustifyH("LEFT")
		SilverSkillScoreSubFrame.text:SetJustifyV("CENTER")
		SilverSkillScoreSubFrame.text:SetTextColor(0,0,0,.7)
		SilverSkillScoreSubFrame.text:SetText(format("5x"))

		Ahoy.TabFrames[t] = AhoyTabFrame
	end
end

function Ahoy_AdjustTabs(number)
	for n = 0, Ahoy.TabsCount, 1 do
		if n > number then
			Ahoy.TabFrames[n]:Hide();
		else
			Ahoy.TabFrames[n]:Show();
		end
	end
end

---------------------------------------------------------
-------------------  Run on Startup  --------------------
---------------------------------------------------------

Ahoy_CreateTabFrames();
Ahoy_AdjustTabs(-1);
Ahoy_WindowSwitch("Splashscreen");

------------------------
-------- UPDATE --------
------------------------

function Ahoy_OnUpdate(self, elapsed)
	Ahoy.TimeSinceLastUpdate = Ahoy.TimeSinceLastUpdate + elapsed; 	
	while (Ahoy.TimeSinceLastUpdate > Ahoy.updateInterval) do
		Ahoy_UpdateLoop()
		Ahoy.TimeSinceLastUpdate = Ahoy.TimeSinceLastUpdate - Ahoy.updateInterval;
	end
end

local Ahoy_UpdateFrame = CreateFrame("frame")
Ahoy_UpdateFrame:SetScript("OnUpdate", Ahoy_OnUpdate)

function Ahoy_UpdateLoop ()
	if Ahoy.animateBackground then
		if Ahoy.windowIsDragged == false then
			Ahoy.cloudTexCoordIncrement = Ahoy.cloudTexCoordIncrement + 0.0004
			SplashscreenWindowFrame_Texture:SetTexCoord(0 + Ahoy.cloudTexCoordIncrement, 1 + Ahoy.cloudTexCoordIncrement, 0, 0.25);
			SplashScreenWaterReflection_Texture:SetTexCoord(0 + Ahoy.cloudTexCoordIncrement, 1 + Ahoy.cloudTexCoordIncrement, 0.125, 0) 
		end
	end
end
